;; Die folgende Funktion fuegt eine Zahl in eine sortierte Liste an der
;; richtigen Stelle ein und lifert die Liste mit dem eingefuegten Element 
;; zurueck.
(defun element_einfuegen (liste element)
   (if (null liste)
       (list element)
       (if (< element (car liste))
           (cons element liste)
           (cons (car liste) (element_einfuegen (cdr liste) element)))))


;; Die folgende Funktion sortiert eine Liste von Zahlen aufsteigend.
;; Die Arbeitsweise ist "Sortieren durch Einfuegen", d.h. die n zu sortierenden
;; Elemente werden nacheinander betrachtet und in die jeweils sortierte, 
;; anfangs leere Liste an der richtigen Stelle eingefuegt.
(defun sortiere (liste)
  (defun iter (liste erg_liste)
      (if (null liste)
         erg_liste
         (iter (cdr liste) (element_einfuegen erg_liste (car liste)))))
  (iter liste '()))

