MODULE Sets EXPORTS Main;

(* 
Bearbeitung folgender Aufgabe:
Schreiben Sie ein Programm, das eine Integer-Zahl einliest. 
Dabei wir SIO.GetChar, nicht aber SIO.GetInt verwenden. 
Die Zahl ist eine Ziffernfolge. Vor der Ziffernfolge sind eventuelle Leerzeichen oder Tabulatoren erlaubt, sie werden einfach berlesen. Ein Vorzeichen kann auch eingegeben werden. 
Wird keine interpretierbare Ziffernfolge eingetippt, sollte eine Fehlermeldung generiert werden. 
ber eventuelle Zeichen anch der Zifferfolge soll eine Statistik gemacht werden.

*)


  IMPORT SIO;
  TYPE
    Zeichenmenge = SET OF CHAR;
  CONST
    Gross = Zeichenmenge{'A' .. 'Z'};
    Klein = Zeichenmenge{'a' .. 'z'};
    Umlaute = Zeichenmenge{'', '', '', '', '', '', ''};
    Buchstabe = Gross + Klein + Umlaute;
    Ziffern = Zeichenmenge{'0' .. '9'};
    Blanks = Zeichenmenge{' ', '\t'}; 
    Vorzeichen = Zeichenmenge{'-', '+'};
    Stopp = '\n';

  VAR
(* ch soll jeweils das letzte Zeichen geben *)
    ch : CHAR;
(* negativ soll am Ende wahr sein gdw. die eingegebene Zahl negativ ist *)
    negativ : BOOLEAN := FALSE;
(* erg soll am Ende das Ergebnis enthalten. *)
    erg: INTEGER := 0;
(* buchstaben, ziffern, sonstige enthalten am Ende die Werte fuer die Statistik *)
    buchstaben, ziffern, sonstige: CARDINAL := 0;

BEGIN
  SIO.PutText("Bitte eine Zahl eingeben: ");
(* Die folgende Schleife filtert Blanks. *)
  REPEAT ch := SIO.GetChar() UNTIL NOT ch IN Blanks;
  IF ch IN Vorzeichen THEN
(* Zahl negativ *)
    negativ := ch = '-';
(* Die folgende Schleife filtert Blanks nach Vorzeichen. *)
    REPEAT ch := SIO.GetChar() UNTIL NOT ch IN Blanks;
  END;
  IF ch IN Ziffern THEN
(* Liest die Ziffern der Zahl *)
    WHILE ch IN Ziffern DO
(* Berechnung des Ergebnisses bis zum aktuellen Zeichen *)
      erg := 10 * erg + (ORD(ch) - ORD('0'));
(* naechstes Zeichen lesen *)
      ch := SIO.GetChar();
    END;
(* Vorzeichen bestimmen *)
    IF negativ THEN erg := -erg END;
(* jetzt lesen, bis das Stoppzeichen gelesen wird *)
    WHILE ch # Stopp DO
      IF ch IN Buchstabe THEN INC(buchstaben)
      ELSIF ch IN Ziffern THEN INC(ziffern)
      ELSE INC(sonstige)
      END;
      ch := SIO.GetChar();
    END;
(* alle Zeichen verarbeitet *)
    SIO.PutText("Eingelesene Zahl = ");
    SIO.PutInt(erg);
    SIO.PutText("\nStatistik der Folgezeichen:\n");
    SIO.PutText("Buchstaben= "); SIO.PutInt(buchstaben);
    SIO.PutText("Ziffern= "); SIO.PutInt(ziffern);
    SIO.PutText("Sonstige= "); SIO.PutInt(sonstige);
    SIO.Nl();
  ELSE
    SIO.PutText("Keine interpretierbare Zahl\n")
  END;
END Sets.