MODULE VierGewinnt EXPORTS Main;

(*
Bearbeitung folgender Aufgabe:
Wir mchten ein Vier-Gewinnt-Spiel programmieren. Das 
Spielbrett steht aufrecht und besteht aus sieben 
Schchten, die jeweils sechs Steine aufnehmen knnen. 
Zwei Spieler spielen gegeneinander, der erste spielt 
mit schwarzen, der zweite mit roten Steinen. Jeder 
Spieler versucht, vier eigene Steine lckenlos in einer
Zeile, einer Spalte oder in einer Diagonalen zu 
plazieren, bevor dies dem Gegner gelingt. Dazu werfen 
die Spieler jeweils abwechselnd einen Stein ihrer Farbe
in einen der sieben Schchte. Wird ein Stein in einen 
Schacht eingeworfen, fllt er bis auf die tiefste noch
freie Position dieses Schachtes.

Definieren Sie in Modula-3 eine geeignete Datenstruktur
fr das Spiel Vier-Gewinnt .

Deklarieren Sie eine Spielbrett-Variable und 
initialisieren Sie diese korrekt, damit das Spiel 
beginnen kann.

Schreiben Sie eine Modula-3 Prozedur SteinEinwerfen, 
die als Parameter die Angabe des Schachtes und die 
Steinfarbe erhlt. Kann der Stein eingeworfen werden, 
dann mu der Inhalt des Spielbretts entsprechend 
verndert sein.

Schreiben Sie eine Modula-3 Funktion HatGewonnen, die 
ermittelt, ob ein Spieler durch Setzen des letzten 
Steins das Spiel gewonnen hat. Die Funktion erhlt als 
Parameter die Schacht- und Positionsangabe des zuletzt 
eingeworfenen Steins.
*)

CONST Schaechte  = 7;
      Positionen = 6;

TYPE Inhalt    = {schwarz, rot, leer};
     Schacht   = [1..Schaechte];
     Position  = [1..Positionen];
     Spielbrett= ARRAY Schacht, Position OF Inhalt;



VAR sb :=
      Spielbrett{ARRAY Position OF Inhalt {Inhalt.leer, ..}, ..};

PROCEDURE SteinEinwerfen(s: Schacht; i: Inhalt): BOOLEAN=
VAR p            : INTEGER;
    platzGefunden: BOOLEAN := FALSE;

BEGIN
  (* Suche freie Position im Schacht von unten nach oben *)
  p := 1;
  WHILE (p <= Positionen) AND (sb[s, p] # Inhalt.leer) DO 
    INC(p)
  END;

  IF (p <= Positionen) THEN sb[s, p] := i; platzGefunden := TRUE; END;

  RETURN platzGefunden;
END SteinEinwerfen;

PROCEDURE HatGewonnen(s: Schacht; p: Position): BOOLEAN=
VAR erg                : BOOLEAN := FALSE;
    zaehler, sNeu, pNeu: INTEGER;
    i                  : Inhalt;
BEGIN
  i := sb[s, p]; (* Farbe des Steins am untersuchten Platz *)
  (* Zaehle Steine auf den Geraden (-1,-1), (-1,0), (-1,1) und (0,-1) *)
  FOR xIndex := -1 TO 0 DO
    FOR yIndex := -1 TO 1 DO
      (* Pruefe nicht (0,0) und (0,1) *)
      IF (xIndex # 0) OR ((yIndex # 0) AND (yIndex # 1)) THEN
        zaehler := 1; (* Eingeworfener Stein *)
        (* Pruefe in positiver Richtung *)
        sNeu := s + xIndex; pNeu := p + yIndex;
        WHILE (zaehler < 4) AND GleicherInhalt(sNeu, pNeu, i) DO
          INC(zaehler); sNeu := sNeu + xIndex; pNeu := pNeu + yIndex;
        END;
        (* Pruefe in negativer Richtung *)
        sNeu := s - xIndex; pNeu := p - yIndex;
        WHILE (zaehler < 4) AND GleicherInhalt(sNeu, pNeu, i) DO
          INC(zaehler); sNeu := sNeu - xIndex; pNeu := pNeu - yIndex;
        END;
        IF (zaehler >= 4) THEN erg := TRUE; END; (* Vier gewinnt! *)
      END;
    END;
  END;
  RETURN erg;
END HatGewonnen;

PROCEDURE GleicherInhalt(s: INTEGER; p: INTEGER; i: Inhalt): BOOLEAN=
(* Prueft, ob Stein noch auf dem Spielbrett und die Farbe von i hat *)
VAR erg: BOOLEAN := FALSE;

BEGIN
  IF (s >= 1) AND (s <= Schaechte) THEN
    IF (p >= 1) AND (p <= Positionen) THEN
      IF (sb[s,p] = i) THEN erg := TRUE; END;
    END;
  END;
  RETURN erg;
END GleicherInhalt;

BEGIN
END VierGewinnt.